
'-------------------------------------------------------------------------------
'Name                     : Softblink.bas
'Copyright                : (c) 2010,   .
'Purpose                  :   
'Processor                : ATTiny13V
'Battery                  : Akk 6V
'Romimage                 : 874 dec
'Crystal                  :  RC- 2
'Compiler                 : BASCOM-AVR demo V 1.11.9.5
'-------------------------------------------------------------------------------


   $regfile = "attiny13.dat"                                ' 
   $crystal = 2000000                                       ' 

   Dim Flag1 As Byte                                        ' 
   Dim Flag2 As Bit

   Dim W1 As Word
   Dim W2 As Word
   Dim W3 As Word

   Dim Sb1 As Byte
   Dim Sb2 As Bit

   Dim I1 As Byte
   Dim I2 As Bit


   Config Portb.0 = Output                                  '   B  
   Config Portb.1 = Output

   Config Pinb.2 = Input                                    '   B  
   Config Pinb.3 = Input
   Config Pinb.4 = Input

   Config Adc = Single , Prescaler = Auto , Reference = Avcc       '  
   Stop Adc                                                 ' 
   Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Down


   Portb.1 = 0
   I1 = 255                                                 '     i1



Do

'--------- .1   --------

   Gosub Akbat
   If Flag1 = 2 Then Gosub But3

'--------------.2.   -----------------

   Gosub Button

   If Sb1 = 1 And I2 = 1 And I1 > 3 Then
   Decr I1
   Pwm0a = I1
   Waitms 6
   End If

   If Sb1 = 2 And I2 = 1 And I1 < 255 Then
   Incr I1
   Pwm0a = I1
   Waitms 6
   End If

'------------.2.    (/)-----------

   Gosub Foto

   If Flag2 = 1 And I2 = 0 Then
   Pwm0a = I1                                               ' 1 2  i1=255
   Waitms 10
   End If

   If Flag2 = 0 And I2 = 0 Then
   Pwm0a = 0
   Waitms 10                                                ' 1  2  i1=0
   End If

'------------------------   --------------------

'  .   4,5 (2   R5R6)  
'  HL2   

   If Flag1 = 1 Then Goto Batlow                            '   .4,5  HL2


Loop



'---------------------------           -----------------------------


'-------------------------------------------------------------------------------
'        .      SB3
'-------------------------------------------------------------------------------
Akbat:

   Portb.2 = 1                                              '  
   Start Adc                                                ' 
   W1 = Getadc(1)                                           '    w1
   Stop Adc                                                 ' 

   If W1 < 682 Then Flag1 = 1                               '   4,5 

   If W1 < 50 Then
   Flag1 = 2                                                '  SB3
   Toggle I2
   End If

Return

'-------------------------------------------------------------------------------
'          SB3  HL2
'-------------------------------------------------------------------------------
But3:

    Flag1 = 0

    If I2 = 1 Then
    Pwm0a = 255
    Set Portb.1
    I1 = 255
    End If

    If I2 = 0 Then
    Pwm0a = 0
    Reset Portb.1
    Reset I1
    End If
    Waitms 250

Return

'-------------------------------------------------------------------------------
'                    SB1(+),SB2(-)
'-------------------------------------------------------------------------------
Button:

   Reset Sb1

   Start Adc                                                ' 
   W2 = Getadc(2)                                           '    w1
   Stop Adc                                                 ' 

   If W2 < 500 Then Sb1 = 1                                 '  SB1 -
   If W2 < 10 Then Sb1 = 2                                  '  SB2 +

Return

'-------------------------------------------------------------------------------
'               
'-------------------------------------------------------------------------------
Foto:

   Start Adc                                                ' 
   W3 = Getadc(3)                                           '    w1
   Stop Adc                                                 ' 

   If W3 > 1020 Then                                        ' -
   Flag2 = 1                                                '
Else
   Flag2 = 0                                                '
   End If
   Delay

Return

'-------------------------------------------------------------------------------
'             
'-------------------------------------------------------------------------------
Batlow:

   Pwm0a = 0                                                ' 1  2
   Stop Timer0

   Portb.1 = 1                                              '   HL2 " "
   Waitms 50
   Portb.1 = 0
   Waitms 50
   Goto Batlow

End